/**
* Nudsf_DataRepository
* Nudsf Data Repository Service. © 2021, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved. 
*
* The version of the OpenAPI document: 1.1.0-alpha.2
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/

#include "BlockCRUDApi.h"
#include "Helpers.h"
#include "logger.hpp"
namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

BlockCRUDApi::BlockCRUDApi(std::shared_ptr<Pistache::Rest::Router> rtr) { 
    router = rtr;
}

void BlockCRUDApi::init() {
    setupRoutes();
}

void BlockCRUDApi::setupRoutes() {
    using namespace Pistache::Rest;

    Routes::Put(*router, base + "/:realmId/:storageId/records/:recordId/blocks/:blockId", Routes::bind(&BlockCRUDApi::create_or_modify_block_handler, this));
    Routes::Delete(*router, base + "/:realmId/:storageId/records/:recordId/blocks/:blockId", Routes::bind(&BlockCRUDApi::delete_block_handler, this));
    Routes::Get(*router, base + "/:realmId/:storageId/records/:recordId/blocks/:blockId", Routes::bind(&BlockCRUDApi::get_block_handler, this));
    Routes::Get(*router, base + "/:realmId/:storageId/records/:recordId/blocks", Routes::bind(&BlockCRUDApi::get_block_list_handler, this));

    // Default handler, called when a route is not found
    router->addCustomHandler(Routes::bind(&BlockCRUDApi::block_crud_api_default_handler, this));
}

void BlockCRUDApi::create_or_modify_block_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    // Getting the path params
    auto realmId = request.param(":realmId").as<std::string>();
    auto storageId = request.param(":storageId").as<std::string>();
    auto recordId = request.param(":recordId").as<std::string>();
    auto blockId = request.param(":blockId").as<std::string>();
    
    // Getting the body param
    
    //AnyType body;
    
    // Getting the query params
    auto getPreviousQuery = request.query().get("get-previous");
    Pistache::Optional<bool> getPrevious;
    if(!getPreviousQuery.isEmpty()){
        bool valueQuery_instance;
        if(fromStringValue(getPreviousQuery.get(), valueQuery_instance)){
            getPrevious = Pistache::Some(valueQuery_instance);
        }
    }
    auto supportedFeaturesQuery = request.query().get("supported-features");
    Pistache::Optional<std::string> supportedFeatures;
    if(!supportedFeaturesQuery.isEmpty()){
        std::string valueQuery_instance;
        if(fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)){
            supportedFeatures = Pistache::Some(valueQuery_instance);
        }
    }
    
    // Getting the header params
    auto ifNoneMatch = request.headers().tryGetRaw("If-None-Match");
    auto ifMatch = request.headers().tryGetRaw("If-Match");

    try {
     // body = request.body();
     // this->create_or_modify_block(realmId, storageId, recordId, blockId, body, getPrevious, ifNoneMatch, ifMatch, supportedFeatures, response);
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }

}
void BlockCRUDApi::delete_block_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    // Getting the path params
    auto realmId = request.param(":realmId").as<std::string>();
    auto storageId = request.param(":storageId").as<std::string>();
    auto recordId = request.param(":recordId").as<std::string>();
    auto blockId = request.param(":blockId").as<std::string>();
    
    // Getting the query params
    auto getPreviousQuery = request.query().get("get-previous");
    Pistache::Optional<bool> getPrevious;
    if(!getPreviousQuery.isEmpty()){
        bool valueQuery_instance;
        if(fromStringValue(getPreviousQuery.get(), valueQuery_instance)){
            getPrevious = Pistache::Some(valueQuery_instance);
        }
    }
    auto supportedFeaturesQuery = request.query().get("supported-features");
    Pistache::Optional<std::string> supportedFeatures;
    if(!supportedFeaturesQuery.isEmpty()){
        std::string valueQuery_instance;
        if(fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)){
            supportedFeatures = Pistache::Some(valueQuery_instance);
        }
    }
    
    // Getting the header params
    auto ifMatch = request.headers().tryGetRaw("If-Match");

    try {
      this->delete_block(realmId, storageId, recordId, blockId, getPrevious, ifMatch, supportedFeatures, response);
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }

}
void BlockCRUDApi::get_block_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    // Getting the path params
    auto realmId = request.param(":realmId").as<std::string>();
    auto storageId = request.param(":storageId").as<std::string>();
    auto recordId = request.param(":recordId").as<std::string>();
    auto blockId = request.param(":blockId").as<std::string>();
    
    Logger::udsf_server().info("--GET!--/%s/%s/records/%s",realmId.c_str(),storageId.c_str(),recordId.c_str());

    // Getting the query params
    auto supportedFeaturesQuery = request.query().get("supported-features");
    Pistache::Optional<std::string> supportedFeatures;
    if(!supportedFeaturesQuery.isEmpty()){
        std::string valueQuery_instance;
        if(fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)){
            supportedFeatures = Pistache::Some(valueQuery_instance);
        }
    }
    
    // Getting the header params
    auto ifNoneMatch = request.headers().tryGetRaw("If-None-Match");
    auto ifModifiedSince = request.headers().tryGetRaw("If-Modified-Since");

    try {
      this->get_block(realmId, storageId, recordId, blockId, ifNoneMatch, ifModifiedSince, supportedFeatures, response);
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }

}
void BlockCRUDApi::get_block_list_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    // Getting the path params
    auto realmId = request.param(":realmId").as<std::string>();
    auto storageId = request.param(":storageId").as<std::string>();
    auto recordId = request.param(":recordId").as<std::string>();
    
    // Getting the query params
    auto supportedFeaturesQuery = request.query().get("supported-features");
    Pistache::Optional<std::string> supportedFeatures;
    if(!supportedFeaturesQuery.isEmpty()){
        std::string valueQuery_instance;
        if(fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)){
            supportedFeatures = Pistache::Some(valueQuery_instance);
        }
    }
    
    try {
      this->get_block_list(realmId, storageId, recordId, supportedFeatures, response);
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }

}

void BlockCRUDApi::block_crud_api_default_handler(const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
    Logger::udsf_server().debug("block_crud_api_default_handler sreceive message");
    response.send(Pistache::Http::Code::Not_Found, "The requested method does not exist");
}

}
}
}
}

