/**
* Nudsf_DataRepository
* Nudsf Data Repository Service. © 2021, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved. 
*
* The version of the OpenAPI document: 1.1.0-alpha.2
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/
/*
 * MetaSchemaCRUDApi.h
 *
 * 
 */

#ifndef MetaSchemaCRUDApi_H_
#define MetaSchemaCRUDApi_H_


#include <pistache/http.h>
#include <pistache/router.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>


#include "MetaSchema.h"
#include "ProblemDetails.h"
#include "Record.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class  MetaSchemaCRUDApi {
public:
    MetaSchemaCRUDApi(std::shared_ptr<Pistache::Rest::Router>);
    virtual ~MetaSchemaCRUDApi() {}
    void init();

    const std::string base = "/nudsf-dr/v1";

private:
    void setupRoutes();

    void create_or_modify_meta_schema_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void delete_meta_schema_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void get_meta_schema_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void meta_schema_crud_api_default_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);

    std::shared_ptr<Pistache::Rest::Router> router;

    /// <summary>
    /// Create/Modify Meta Schema
    /// </summary>
    /// <remarks>
    /// Create or Modify a Meta Schema with a user provided SchemaId
    /// </remarks>
    /// <param name="realmId">Identifier(name) of the Realm</param>
    /// <param name="storageId">Identifier of the Storage</param>
    /// <param name="schemaId">Identifier of the Meta Schema</param>
    /// <param name="metaSchema"></param>
    /// <param name="ifNoneMatch">Validator for conditional requests, as described in RFC 7232, 3.2 (optional, default to &quot;&quot;)</param>
    /// <param name="ifMatch">Validator for conditional requests, as described in RFC 7232, 3.2 (optional, default to &quot;&quot;)</param>
    /// <param name="getPrevious">Retrieve the Meta Schema before update (optional, default to false)</param>
    /// <param name="supportedFeatures">Features required to be supported by the target NF (optional, default to &quot;&quot;)</param>
    virtual void create_or_modify_meta_schema(const std::string &realmId, const std::string &storageId, const std::string &schemaId, const MetaSchema &metaSchema, const Pistache::Optional<Pistache::Http::Header::Raw> &ifNoneMatch, const Pistache::Optional<Pistache::Http::Header::Raw> &ifMatch, const Pistache::Optional<bool> &getPrevious, const Pistache::Optional<std::string> &supportedFeatures, Pistache::Http::ResponseWriter &response) = 0;

    /// <summary>
    /// Delete a Meta Schema with an user provided SchemaId
    /// </summary>
    /// <remarks>
    /// 
    /// </remarks>
    /// <param name="realmId">Identifier(name) of the Realm</param>
    /// <param name="storageId">Identifier of the Storage</param>
    /// <param name="schemaId">Identifier of the Meta Schema</param>
    /// <param name="ifMatch">Record validator for conditional requests, as described in RFC 7232, 3.2 (optional, default to &quot;&quot;)</param>
    /// <param name="getPrevious">Retrieve the Meta Schema before delete (optional, default to false)</param>
    /// <param name="supportedFeatures">Features required to be supported by the target NF (optional, default to &quot;&quot;)</param>
    virtual void delete_meta_schema(const std::string &realmId, const std::string &storageId, const std::string &schemaId, const Pistache::Optional<Pistache::Http::Header::Raw> &ifMatch, const Pistache::Optional<bool> &getPrevious, const Pistache::Optional<std::string> &supportedFeatures, Pistache::Http::ResponseWriter &response) = 0;

    /// <summary>
    /// Meta Schema access
    /// </summary>
    /// <remarks>
    /// retrieve one specific Meta Schema
    /// </remarks>
    /// <param name="realmId">Identifier of the Realm</param>
    /// <param name="storageId">Identifier of the Storage</param>
    /// <param name="schemaId">Identifier of the Meta Schema</param>
    /// <param name="ifNoneMatch">Validator for conditional requests, as described in RFC 7232, 3.2 (optional, default to &quot;&quot;)</param>
    /// <param name="ifModifiedSince">Validator for conditional requests, as described in RFC 7232, 3.3 (optional, default to &quot;&quot;)</param>
    /// <param name="supportedFeatures">Features required to be supported by the target NF (optional, default to &quot;&quot;)</param>
    virtual void get_meta_schema(const std::string &realmId, const std::string &storageId, const std::string &schemaId, const Pistache::Optional<Pistache::Http::Header::Raw> &ifNoneMatch, const Pistache::Optional<Pistache::Http::Header::Raw> &ifModifiedSince, const Pistache::Optional<std::string> &supportedFeatures, Pistache::Http::ResponseWriter &response) = 0;

};

}
}
}
}

#endif /* MetaSchemaCRUDApi_H_ */

