/**
* Nudsf_DataRepository
* Nudsf Data Repository Service. © 2021, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved. 
*
* The version of the OpenAPI document: 1.1.0-alpha.2
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/

#include "NotificationSubscriptionsCRUDApi.h"
#include "Helpers.h"
#include "logger.hpp"
namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

NotificationSubscriptionsCRUDApi::NotificationSubscriptionsCRUDApi(std::shared_ptr<Pistache::Rest::Router> rtr) { 
    router = rtr;
}

void NotificationSubscriptionsCRUDApi::init() {
    setupRoutes();
}

void NotificationSubscriptionsCRUDApi::setupRoutes() {
    using namespace Pistache::Rest;

    Routes::Get(*router, base + "/:realmId/:storageId/subs-to-notify", Routes::bind(&NotificationSubscriptionsCRUDApi::get_notification_subscriptions_handler, this));

    // Default handler, called when a route is not found
    router->addCustomHandler(Routes::bind(&NotificationSubscriptionsCRUDApi::notification_subscriptions_crud_api_default_handler, this));
}

void NotificationSubscriptionsCRUDApi::get_notification_subscriptions_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    // Getting the path params
    auto realmId = request.param(":realmId").as<std::string>();
    auto storageId = request.param(":storageId").as<std::string>();
    
    // Getting the query params
    auto limitRangeQuery = request.query().get("limit-range");
    Pistache::Optional<int32_t> limitRange;
    if(!limitRangeQuery.isEmpty()){
        int32_t valueQuery_instance;
        if(fromStringValue(limitRangeQuery.get(), valueQuery_instance)){
            limitRange = Pistache::Some(valueQuery_instance);
        }
    }
    auto supportedFeaturesQuery = request.query().get("supported-features");
    Pistache::Optional<std::string> supportedFeatures;
    if(!supportedFeaturesQuery.isEmpty()){
        std::string valueQuery_instance;
        if(fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)){
            supportedFeatures = Pistache::Some(valueQuery_instance);
        }
    }
    
    try {
      this->get_notification_subscriptions(realmId, storageId, limitRange, supportedFeatures, response);
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }

}

void NotificationSubscriptionsCRUDApi::notification_subscriptions_crud_api_default_handler(const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
    Logger::udsf_server().debug("notification_subscriptions_crud_api_default_handler sreceive message");
    response.send(Pistache::Http::Code::Not_Found, "The requested method does not exist");
}

}
}
}
}

